#include "ti86asm.inc"
_runIndicOff            equ     $4AB1
_clrWindow      		.equ    4A86h
_homeUp         		.equ    4A95h

.org _asm_exec_ram

	nop
	jp MainMenu
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Polyatomic ions",0
ColumnNames:
	.db " Name        Formula ",0
ColumnNamesa:
	.db " Name         Charge ",0
ProgTitle:
	.db "Polyatomic Ions  v1.0",0
AdjCon:
	.db "+/- Adjust Contrast",0
IonPage1:
	.db "acetate        C",Lsub2,"H",Lsub3,"O",Lsub2
	.db "chlorate         ClO",Lsub3
	.db "chlorite         ClO",Lsub2
	.db "cyanide            CN"
	.db "hydroxide          OH"
	.db "hypochlorite      ClO",0
IonPage2:
	.db "iodate            IO",Lsub3
	.db "nitrate           NO",Lsub3
	.db "nitrite           NO",Lsub2
	.db "perchlorate      ClO",Lsub4
	.db "permanganate     MnO",Lsub4
	.db "carbonate         CO",Lsub3,0
IonPage3:
	.db "chromate         CrO",Lsub4
	.db "dichromate      Cr",Lsub2,"O",Lsub7 
	.db "Bromate          BrO",Lsub3
	.db "sulfate           SO",Lsub4
	.db "sulfite           SO",Lsub3
	.db "peroxide           O",Lsub2,0
IonPage4:

	.db "Hydrogen sulfate HSO",Lsub4
	.db "phosphate         PO",Lsub4
	.db "ammonium          NH",Lsub4,0
IonPage5:
	.db "hydrogen phosphate   "
	.db "               ",LupArrow," HPO",Lsub4
	.db "dihydrogen phosphate "
	.db "              ",LupArrow," H",Lsub2,"PO",Lsub4
	.db "hydrogen carbonate   "
	.db "               ",LupArrow," HCO",Lsub3,0
chargePage1:
	.db "acetate            -1"
	.db "chlorate           -1"
	.db "chlorite           -1"
	.db "cyanide            -1"
	.db "hydroxide          -1"
	.db "hypochlorite       -1",0
chargePage2:
	.db "iodate             -1"   
	.db "nitrate            -1"
	.db "nitrite            -1"
	.db "perchlorate        -1"
	.db "permanganate       -1"     
	.db "carbonate          -2",0
chargePage3:
	.db "chromate           -2"
	.db "dichromate         -2"
	.db "phosphate          -3"
	.db "ammonium           +1"
	.db "Bromate            -1"
	.db "sulfate            -2",0
chargePage4:
	.db "sulfite            -2"
	.db "hydrogen carbonate -1"
	.db "Hydrogen sulfate   -1"
	.db "mercury(1)         +2"
	.db "hydrogen carbonate -1"
	.db "                     ",0                     
chargePage5:
	.db "dihydrogen phosphate "
	.db "                 ",LupArrow," -1",0
Keys:
	.db "   <  >  Turn page                    [ Exit ] Main menu",0

MyName:
	.db "   By: Adam Martin    ",0
QstnString:
	.db "    Name & Charge or Name & Formula ?",0
GetKeyLoop:
	call _getkey
	cp kF1
	jp z,F1Pressed
	cp kF5
	jp z,F5Pressed
	cp kF3
	jp z,DMolecules
	cp kAdd
	jp z,MoreCon
	cp kSub
	jp z,LessCon
	cp kExit
	jr z,Exit
	jr GetKeyLoop
Exit:
	call _clrLCD
	ret
blcktop:
	set	3,(iy+5)
	call _puts
	res	3,(iy+5)
	ret
FuncMenu:
	.db " N&C                    "
	.db "                  Diato"
	.db "mic                  "
	.db "             "
	.db "N&F ",0
MainMenu:
	call _runIndicOff
	call _clrScrn
	call _homeup
	ld hl,ProgTitle
	call blcktop
    ld hl,$0800
	ld (_penCol),hl
	ld hl,AdjCon
	call _vputs
	ld hl,$0003
	ld (_curRow),hl
	ld hl,MyName
	call _puts
    ld hl,$3900
	ld (_penCol),hl
	ld hl,FuncMenu
	call _vputs
	ld hl,$3200
	ld (_penCol),hl
	ld hl,QstnString
	call _vputs
	call bottomblack
	jp GetKeyLoop
bottomblack:
    ld b,112
    ld hl,$FF90
Draw_1:
    ld a,(hl)
    cpl
    ld (hl),a
    inc	hl
    djnz Draw_1
	ret
F1Pressed:
	call _clrLCD
	call _homeup
	ld hl,ColumnNamesa
	call blcktop
    ld hl,$3900
	ld (_penCol),hl
	ld hl,Keys
	call _vputs
	call bottomblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,chargePage1
	call _puts
GKLa:
	call _getkey
	cp kRight
	jp z,Page2a
	cp kLeft
	jp z,Page5a
	cp kExit
	jp z,MainMenu
	jr GKLa

F5Pressed:
	call _clrLCD
	call _homeup
	ld hl,ColumnNames
	call blcktop
    ld hl,$3900
	ld (_penCol),hl
	ld hl,Keys
	call _vputs
	call bottomblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,IonPage1
	call _puts
GKL:
	call _getkey
	cp kRight
	jp z,Page2
	cp kLeft
	jp z,Page5
	cp kExit
	jp z,MainMenu
	jr GKL
GKL2:
	call _getkey
	cp kRight
	jp z,Page3
	cp kLeft
	jp z,F5Pressed
	cp kExit
	jp z,MainMenu
	jr GKL2
GKL3:
	call _getkey
	cp kRight
	jp z,Page4
	cp kLeft
	jp z,Page2
	cp kExit
	jp z,MainMenu
	jr GKL3
GKL4:
	call _getkey
	cp kRight
	jp z,Page5
	cp kLeft
	jp z,Page3
	cp kExit
	jp z,MainMenu
	jr GKL4
GKL5:
	call _getkey
	cp kRight
	jp z,F5Pressed
	cp kLeft
	jp z,Page4
	cp kExit
	jp z,MainMenu
	jr GKL5
Page2:
	call n2dblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,IonPage2
	call _puts
	jp GKL2

n2dblack:
	call _clrLCD
	call _homeup
	ld hl,ColumnNames
	call blcktop
    ld hl,$3900
	ld (_penCol),hl
	ld hl,Keys
	call _vputs
	call bottomblack
	ret
Page3:
	call n2dblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,IonPage3
	call _puts
	jp GKL3
Page4:
	call n2dblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,IonPage4
	call _puts
	jp GKL4
Page5:
	call n2dblack
	ld hl,$01
	ld (_curRow),hl
	ld hl,IonPage5
	call _puts
	jp GKL5
MoreCon:
	ld a,($C008)
	inc a
	ld ($C008),a
	Out (2),a
	jp GetKeyLoop
LessCon:
	ld a,1
	ld a,($C008)
	dec a
	ld ($C008),a
	Out (2),a
	jp GetKeyLoop
GKL2a:
	call _getkey
	cp kRight
	jp z,Page3a
	cp kLeft
	jp z,F1Pressed
	cp kExit
	jp z,MainMenu
	jr GKL2a
GKL3a:
	call _getkey
	cp kRight
	jp z,Page4a
	cp kLeft
	jp z,Page2a
	cp kExit
	jp z,MainMenu
	jr GKL3a
GKL4a:
	call _getkey
	cp kRight
	jp z,Page5a
	cp kLeft
	jp z,Page3a
	cp kExit
	jp z,MainMenu
	jr GKL4a
GKL5a:
	call _getkey
	cp kRight
	jp z,F1Pressed
	cp kLeft
	jp z,Page4a
	cp kExit
	jp z,MainMenu
	jr GKL5a
Page2a:
	call n2dblacka
	ld hl,$01
	ld (_curRow),hl
	ld hl,chargePage2
	call _puts
	jp GKL2a

n2dblacka:
	call _clrLCD
	call _homeup
	ld hl,ColumnNamesa
	call blcktop
    ld hl,$3900
	ld (_penCol),hl
	ld hl,Keys
	call _vputs
	call bottomblack
	ret
Page3a:
	call n2dblacka
	ld hl,$01
	ld (_curRow),hl
	ld hl,chargePage3
	call _puts
	jp GKL3a
Page4a:
	call n2dblacka
	ld hl,$01
	ld (_curRow),hl
	ld hl,chargePage4
	call _puts
	jp GKL4a
Page5a:
	call n2dblacka
	ld hl,$01
	ld (_curRow),hl
	ld hl,chargePage5
	call _puts
	jp GKL5a
DMolecules:
	call _clrLCD
	call _homeup
	ld hl,DTOMICLIST
	call _puts
DTMCGKL:
	call _getkey
	cp kExit
	jp z,MainMenu
	jr DTMCGKL
DTOMICLIST:
	.db "hydrogen           H",Lsub2
	.db "nitrogen           N",Lsub2
	.db "oxygen             O",Lsub2
	.db "flourine           F",Lsub2
	.db "chlorine          Cl",Lsub2 
	.db "bromine           Br",Lsub2
	.db "iodine             I",Lsub2,0